
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Nasa_Classes &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Nasa_Classes</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>
<span class="kn">import</span> <span class="nn">scipy.io</span>
<span class="kn">import</span> <span class="nn">pickle</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">math</span>
<span class="kn">from</span> <span class="nn">Cleaning</span> <span class="kn">import</span> <span class="o">*</span>

<div class="viewcode-block" id="Dataset_Nasa"><a class="viewcode-back" href="../sphinx/NASA.html#Nasa_Classes.Dataset_Nasa">[docs]</a><span class="k">class</span> <span class="nc">Dataset_Nasa</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Nasa Dataset class. This is based on the &quot;Battery Data Set&quot; by B. Saha and</span>
<span class="sd">    K. Goebel (check note for full reference).</span>

<span class="sd">    One ``Dataset_Nasa`` object corresponds to one battery/one &#39;.mat&#39; file.</span>

<span class="sd">    This class has attribute :py:attr:`~cycle` which is a list with every cycle</span>
<span class="sd">    (:class:`~Nasa_Classes.Nasa_Cycle` objects), which in turn have a</span>
<span class="sd">    :py:attr:`~data` attribute (:class:`~Nasa_Classes.Nasa_Data` object) with</span>
<span class="sd">    the measured data.</span>

<span class="sd">    That way, to reach into measured data:</span>

<span class="sd">    &gt;&gt;&gt; A = Dataset_Nasa(&#39;B0001.txt&#39;)</span>
<span class="sd">    &gt;&gt;&gt; measured_current = Dataset_Nasa.cycle[0].data.meas_i</span>
<span class="sd">    &gt;&gt;&gt; measured_voltage = Dataset_Nasa.cycle[0].data.meas_v</span>

<span class="sd">    .. note::</span>
<span class="sd">        Full reference: B. Saha and K. Goebel (2007). &quot;Battery Data Set&quot;,</span>
<span class="sd">        NASA Ames Prognostics Data Repository</span>
<span class="sd">        &lt;https://ti.arc.nasa.gov/tech/dash/groups/pcoe/prognostic-data-repository/#battery&gt;,</span>
<span class="sd">        NASA Ames Research Center, Moffett Field, CA</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    file_name : string</span>
<span class="sd">        The name of the .mat file, including the extension.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    Name : str</span>
<span class="sd">        The battery ID (example: &#39;B0005&#39;).</span>
<span class="sd">    cycle : list[Nasa_Cycle]</span>
<span class="sd">        List of the cycles tested.</span>
<span class="sd">        See :class:`~Nasa_Classes.Nasa_Cycle` and</span>
<span class="sd">        :class:`~Nasa_Classes.Nasa_Data` classes for more information.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">file_name</span><span class="p">):</span>

        <span class="n">Mat</span>  <span class="o">=</span> <span class="n">scipy</span><span class="o">.</span><span class="n">io</span><span class="o">.</span><span class="n">loadmat</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>          <span class="c1"># Loading the .mat file</span>
        <span class="n">Name</span> <span class="o">=</span> <span class="n">file_name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;.&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>      <span class="c1"># Just taking the name of the battery</span>
        <span class="n">shp</span>  <span class="o">=</span> <span class="n">Mat</span><span class="p">[</span><span class="n">Name</span><span class="p">][</span><span class="s1">&#39;cycle&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">shape</span>       <span class="c1"># Shape of the cycle matrix</span>

        <span class="c1"># Reshaping from (1,N) to (N,) for practical reasons, saving it as cycle</span>
        <span class="n">cycle</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">Mat</span><span class="p">[</span><span class="n">Name</span><span class="p">][</span><span class="s1">&#39;cycle&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="n">shp</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>

        <span class="c1"># Initializing the self.cycle list</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">cycle</span><span class="p">)):</span>
            <span class="n">c_i</span> <span class="o">=</span> <span class="n">Nasa_Cycle</span><span class="p">(</span><span class="n">cycle</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">i</span><span class="p">)</span>     <span class="c1"># Go to Nasa_Cycle class.</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">c_i</span><span class="p">)</span>

        <span class="c1"># Other information present in the .mat file, just in case:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">header</span>  <span class="o">=</span> <span class="n">Mat</span><span class="p">[</span><span class="s1">&#39;__header__&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">version</span> <span class="o">=</span> <span class="n">Mat</span><span class="p">[</span><span class="s1">&#39;__version__&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">globals</span> <span class="o">=</span> <span class="n">Mat</span><span class="p">[</span><span class="s1">&#39;__globals__&#39;</span><span class="p">]</span>
        <span class="c1"># Let&#39;s also save its name:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="n">Name</span></div>

<div class="viewcode-block" id="Nasa_Cycle"><a class="viewcode-back" href="../sphinx/NASA.html#Nasa_Classes.Nasa_Cycle">[docs]</a><span class="k">class</span> <span class="nc">Nasa_Cycle</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Nasa Cycle class. This includes all of the cycle&#39;s information.</span>

<span class="sd">    This class is called upon initialization of the :class:`~Dataset_Nasa`</span>
<span class="sd">    class.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    CYCLE : dict</span>
<span class="sd">        A dictionary containing all of the cycle&#39;s information except its number</span>
<span class="sd">    CYCLE_NB : int</span>
<span class="sd">        The cycle&#39;s number.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">        number : int</span>
<span class="sd">            The cycle number.</span>
<span class="sd">        type : {&#39;charge&#39;, &#39;discharge&#39;, &#39;impedance&#39;}</span>
<span class="sd">            The cycle type.</span>
<span class="sd">        amb_T : int</span>
<span class="sd">            The ambient temperature during measurements [ºC].</span>
<span class="sd">            (The raw data was already an integer, I just kept it this way)</span>
<span class="sd">        time : [datetime.datetime]</span>
<span class="sd">            The date and time of the experiment [datetime.datetime]</span>
<span class="sd">        unix_time : float</span>
<span class="sd">            The date and time of the experiment expressed in unix time [s]</span>
<span class="sd">        data : Nasa_Data</span>
<span class="sd">            Nasa_Data object containing all of the actual data.</span>
<span class="sd">            See Nasa_Data for more information.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">CYCLE</span><span class="p">,</span> <span class="n">CYCLE_NB</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">CYCLE_NB</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">type</span>   <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span>                      <span class="c1"># The type of cycle (charge, discharge or impedance)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span>  <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;ambient_temperature&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>     <span class="c1"># The ambient temperature of the measurements</span>

        <span class="c1"># Time conversion for datetime.datetime object and UNIX</span>
        <span class="n">Y</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">]))</span>
        <span class="n">m</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">]))</span>
        <span class="n">d</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">]))</span>
        <span class="n">H</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">3</span><span class="p">]))</span>
        <span class="n">M</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">4</span><span class="p">]))</span>
        <span class="n">S</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">5</span><span class="p">]))</span>
        <span class="n">time_str</span> <span class="o">=</span> <span class="n">Y</span> <span class="o">+</span> <span class="s1">&#39;/&#39;</span> <span class="o">+</span> <span class="n">m</span> <span class="o">+</span> <span class="s1">&#39;/&#39;</span> <span class="o">+</span> <span class="n">d</span> <span class="o">+</span> <span class="s1">&#39; &#39;</span> <span class="o">+</span> <span class="n">H</span> <span class="o">+</span> <span class="s1">&#39;:&#39;</span> <span class="o">+</span> <span class="n">M</span> <span class="o">+</span> <span class="s1">&#39;:&#39;</span> <span class="o">+</span> <span class="n">S</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">strptime</span><span class="p">(</span><span class="n">time_str</span><span class="p">,</span> <span class="s1">&#39;%Y/%m/</span><span class="si">%d</span><span class="s1"> %H:%M:%S&#39;</span><span class="p">)</span>    <span class="c1"># Time as datetime object</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">unix_time</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">time</span><span class="o">.</span><span class="n">timestamp</span><span class="p">()</span>                          <span class="c1"># Time in UNIX format (seconds since 1970)</span>

        <span class="c1">#print(self.time) # for bugfixing</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">Nasa_Data</span><span class="p">(</span><span class="n">CYCLE</span><span class="p">[</span><span class="s1">&#39;data&#39;</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">type</span><span class="p">)</span>                 <span class="c1"># The actual data, see Nasa_Data class</span></div>

<div class="viewcode-block" id="Nasa_Data"><a class="viewcode-back" href="../sphinx/NASA.html#Nasa_Classes.Nasa_Data">[docs]</a><span class="k">class</span> <span class="nc">Nasa_Data</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Nasa Data class. Includes all of the actually measured data.</span>

<span class="sd">    The attributes of this class depend on the cycle type (&#39;charge&#39;,</span>
<span class="sd">    &#39;discharge&#39; or &#39;impedance&#39;). That&#39;s the reason why this is a required input.</span>

<span class="sd">     This class is called directly upon initialization of the</span>
<span class="sd">     :class:`~Nasa_Cycle` class.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Data : dict</span>
<span class="sd">        Dictionary containing all of the data.</span>
<span class="sd">    Type : {&#39;charge&#39;, &#39;discharge&#39;, &#39;impedance&#39;}</span>
<span class="sd">        The cycle type.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    sense_i : ndarray[float]</span>
<span class="sd">        Current in sens branch [A] (only for impedance cycles).</span>
<span class="sd">    battery_i : ndarray[float]</span>
<span class="sd">        Current in battery branch [A] (only for impedance cycles).</span>
<span class="sd">    ratio_i : ndarray[float]</span>
<span class="sd">        Ratio of the above currents [] (only for impedance cycles).</span>
<span class="sd">    battery_z : ndarray[float]</span>
<span class="sd">        Battery Impedance computed from raw data [Ohms]</span>
<span class="sd">        (only for impedance cycles).</span>

<span class="sd">    rectified_z : ndarray[float]</span>
<span class="sd">        Calibrated and smoothed battery impedance [Ohms]</span>
<span class="sd">        (only for impedance cycles).</span>

<span class="sd">    Re : float or complex</span>
<span class="sd">        Estimated electrolyte resistance [Ohms] (only for impedance cycles).</span>
<span class="sd">    Rct : float</span>
<span class="sd">        Estimated charge transfer resistance [Ohms] (only for impedance cycles).</span>
<span class="sd">    time : ndarray[float]</span>
<span class="sd">        Time vector for the cycle [s] (for charge and discharge cycles).</span>
<span class="sd">    meas_v : ndarray[float]</span>
<span class="sd">        Battery terminal voltage [V] (for charge and discharge cycles).</span>
<span class="sd">    meas_i : ndarray[float]</span>
<span class="sd">        Battery output current [A] (for charge and discharge cycles).</span>
<span class="sd">    meas_t : ndarray[float]</span>
<span class="sd">        Battery temperature [ºC] (for charge and discharge cycles).</span>
<span class="sd">    charge_i : ndarray[float]</span>
<span class="sd">        Current measured at charger [A] (only for charge cycles).</span>
<span class="sd">    charge_v : ndarray[float]</span>
<span class="sd">        Voltage measured at charger [V] (only for charge cycles).</span>
<span class="sd">    load_i : ndarray[float]</span>
<span class="sd">        Current measured at load [A] (only for discharge cycles).</span>
<span class="sd">    load_v : ndarray[float]</span>
<span class="sd">        Voltage measured at load [V] (only for discharge cycles).</span>
<span class="sd">    capacity : float</span>
<span class="sd">        Battery capacity for discharge till 2.7V [A.h]</span>
<span class="sd">        (only for discharge cycles).</span>


<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Data</span><span class="p">,</span> <span class="n">Type</span><span class="p">):</span>

        <span class="c1"># Data is Cycle[&#39;data&#39;] whilst Type is Cycle[&#39;type&#39;]</span>

        <span class="k">if</span> <span class="n">Type</span> <span class="o">==</span> <span class="s1">&#39;impedance&#39;</span><span class="p">:</span>
            <span class="c1">#(!!!) AN ADAPTATION OF SHAPES AND MATRICES MAY BE NECESSARY (?)</span>
            <span class="c1"># In this case we have as attributes:</span>
            <span class="c1"># Sense_current</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">sense_i</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Sense_current&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
            <span class="c1"># Battery_current</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">battery_i</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Battery_current&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
            <span class="c1"># Current_ratio</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">ratio_i</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Current_ratio&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
            <span class="c1"># Battery_impedance</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">battery_z</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Battery_impedance&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">]</span>
            <span class="c1"># Rectified_Impedance</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">rectified_z</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Rectified_Impedance&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">]</span>
            <span class="c1"># Re  (estimated electrolyte resistance in Ohms)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">Re</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Re&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">item</span><span class="p">()</span>
            <span class="c1"># Rct (estimated charge transfer resistance in Ohms)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">Rct</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Rct&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">item</span><span class="p">()</span>

        <span class="k">else</span><span class="p">:</span>   <span class="c1"># If the type isn&#39;t impedance, then it&#39;s either charge or discharge which have a lot in common:</span>

            <span class="c1"># Voltage_measured</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Voltage_measured&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
            <span class="c1"># Current_measured</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Current_measured&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
            <span class="c1"># Temperature_measured</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">meas_t</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Temperature_measured&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
            <span class="c1"># Time</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Time&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">])</span>

            <span class="k">if</span> <span class="n">Type</span> <span class="o">==</span> <span class="s1">&#39;charge&#39;</span><span class="p">:</span>
                <span class="c1"># Current_charge</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">charge_i</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Current_charge&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
                <span class="c1"># Voltage_charge</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">charge_v</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Voltage_charge&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># Current_load</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">load_i</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Current_load&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
                <span class="c1"># Voltage_load</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">load_v</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Voltage_load&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
                <span class="c1"># Capacity</span>
                <span class="c1"># The following &#39;try:&#39; statement is necessary because</span>
                <span class="c1"># some files have missing Capacity data</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">Data</span><span class="p">[</span><span class="s1">&#39;Capacity&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">])</span>
                <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;No Capacity value&#39;</span><span class="p">)</span>
                    <span class="c1"># maybe not the best way of dealing with this</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="s1">&#39;nan&#39;</span><span class="p">)</span></div>

<div class="viewcode-block" id="Clean_Battery"><a class="viewcode-back" href="../sphinx/NASA.html#Nasa_Classes.Clean_Battery">[docs]</a><span class="k">class</span> <span class="nc">Clean_Battery</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Class that holds the cleaned cycle couples and their data for one Battery.</span>

<span class="sd">    It takes as a base one Dataset_Nasa class (one Battery from the Nasa</span>
<span class="sd">    Dataset). From it, it extracts the cycle couples associated to the model&#39;s</span>
<span class="sd">    inputs and outputs (first a discharge cycle, related to the capacity values,</span>
<span class="sd">    and then the charge cycle that comes immediately after for the inputs).</span>
<span class="sd">    Then, it cleans each one of the selected cycles excluding the couples that</span>
<span class="sd">    present abnormalities.</span>

<span class="sd">    It cleans the charge cycle by taking away the first few points before the</span>
<span class="sd">    actual cycle begins and the last ones after the current has reached its</span>
<span class="sd">    cut-off point (&lt; `i_cutoff`).</span>

<span class="sd">    Couples are excluded in this process when:</span>
<span class="sd">        The discharge curve&#39;s capacity value is nan, or it&#39;s below the</span>
<span class="sd">        `threshold` value.</span>
<span class="sd">        When the charge cycle is too short (&lt; `min_len`).</span>
<span class="sd">    The cycle couples that weren&#39;t excluded then pass by an outlier detection</span>
<span class="sd">    based on the capacity value. Ouliers are detected by sliding windows and</span>
<span class="sd">    z-score values.</span>

<span class="sd">    The remaining, &quot;valid&quot; cycle couples are saved in the attribute `couples`.</span>
<span class="sd">    No resampling is done at this stage, only during dataset creation for model</span>
<span class="sd">    training/validation.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Battery : Dataset_Nasa</span>
<span class="sd">        The battery we want to create the class for.</span>
<span class="sd">    i_cutoff : float, default = 2e-2</span>
<span class="sd">        The current cut-off value to be used to determine the end of the charge</span>
<span class="sd">        cycles [A].</span>
<span class="sd">    min_len : int, default = 1</span>
<span class="sd">        The minimum amount of points a charge cycle must have to be considered</span>
<span class="sd">        as relevant. Equal to one by default. Something similar is done during</span>
<span class="sd">        the resampling stages in the dataset creation.</span>
<span class="sd">    threshold : float, default = 0.1</span>
<span class="sd">        the minimum capacity value to be considered as relevant [A.h].</span>
<span class="sd">    z_lim : float</span>
<span class="sd">        The maximum zscore allowed when searching for outliers.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    Name : string</span>
<span class="sd">        The battery&#39;s name.</span>
<span class="sd">    capacity_curve : ndarray[float, float]</span>
<span class="sd">        A 2D array where the first column corresponds to the cycle couple number</span>
<span class="sd">        and the second to the associated capacity value [[], A.h].</span>
<span class="sd">    raw_couples : list[tuple(int)]</span>
<span class="sd">        The number of the charge and discharge cycles in each couple, based on</span>
<span class="sd">        the Dataset_Nasa&#39;s cycle numbers.</span>

<span class="sd">        Example:</span>
<span class="sd">        self.couples[k] = (charge cycle number, discharge cycle number)</span>
<span class="sd">        Battery.cycle[charge cycle number] = Nasa_Cycle object corresponding to</span>
<span class="sd">        the couple&#39;s charge cycle. Analogous for the discharge cycle.</span>
<span class="sd">    couples : list[tuple(int)]</span>
<span class="sd">        Exactly like the ``raw_couples`` attribute, but without the entries that</span>
<span class="sd">        are judged as abnormal or that have missing datapoints or that are too</span>
<span class="sd">        short etc..</span>
<span class="sd">    cycle_couple : list[tuple(Clean_Cycle)]</span>
<span class="sd">        The Clean_Cycle objects corresponding to each couple.</span>
<span class="sd">        self.cycle_couple[k] = (charge Clean_Cycle, discharge Clean_Cycle)</span>
<span class="sd">    capacity_curve : np.ndarray</span>
<span class="sd">        Array with the capacity value for each discharge cycle. The first</span>
<span class="sd">        column corresponds to the cycle&#39;s number and the second one to the</span>
<span class="sd">        capacity value [A.h].</span>
<span class="sd">    C_rate : float</span>
<span class="sd">        The C rate associated to the battery for nondimensionning the</span>
<span class="sd">        current [A].</span>
<span class="sd">    Q_nominal : float</span>
<span class="sd">        The battery&#39;s nominal capacity (for nondimensionning the SOH) [A.h].</span>
<span class="sd">    V_nominal : float</span>
<span class="sd">        The battery&#39;s nominal voltage (for nondimensionning the voltage) [V].</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Battery</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="o">=</span><span class="mf">2e-2</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span>
                 <span class="n">z_lim</span><span class="o">=</span><span class="mi">3</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">C_rate</span> <span class="o">=</span> <span class="mf">2.1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">V_nominal</span> <span class="o">=</span> <span class="mf">4.2</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Q_nominal</span> <span class="o">=</span> <span class="mf">2.1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">Name</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">couples</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="p">[]</span>


        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">)):</span>
            <span class="k">assert</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">number</span> <span class="o">==</span> <span class="n">i</span>

        <span class="c1"># chr_nb = -1</span>
        <span class="c1"># for Cycle in Battery.cycle:</span>
        <span class="c1">#     if Cycle.type == &#39;charge&#39;:</span>
        <span class="c1">#         chr_nb = Cycle.number</span>
        <span class="c1">#     elif Cycle.type == &#39;discharge&#39;:</span>
        <span class="c1">#         if chr_nb != -1:</span>
        <span class="c1">#             dis_nb = Cycle.number</span>
        <span class="c1">#             self.couples.append((chr_nb, dis_nb))</span>
        <span class="c1">#             chr_nb = -1</span>

        <span class="c1"># The charge cycle should come right after the discharge one</span>
        <span class="n">dis_nb</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>
        <span class="k">for</span> <span class="n">Cycle</span> <span class="ow">in</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;discharge&#39;</span><span class="p">:</span>
                    <span class="n">dis_nb</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">number</span>
            <span class="k">elif</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;charge&#39;</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">dis_nb</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span><span class="p">:</span>
                    <span class="n">chr_nb</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">number</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">couples</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_nb</span><span class="p">,</span> <span class="n">dis_nb</span><span class="p">))</span>
                    <span class="n">dis_nb</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>

        <span class="k">for</span> <span class="n">couple</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">couples</span><span class="p">:</span> <span class="c1"># For each charge/discharge couple:</span>
            <span class="c1"># Saving the cycles</span>
            <span class="n">chr_cycle</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="n">couple</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span>    <span class="c1"># The charge cycle</span>
            <span class="n">dis_cycle</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">[</span><span class="n">couple</span><span class="p">[</span><span class="mi">1</span><span class="p">]]</span>    <span class="c1"># The discharge cycle</span>

            <span class="c1"># For the discharge cycle first:</span>
            <span class="k">if</span> <span class="n">math</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">dis_cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">):</span> <span class="c1"># if the capacity is nan:</span>
                <span class="k">continue</span>    <span class="c1"># skip this couple</span>
            <span class="k">elif</span> <span class="n">dis_cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span> <span class="o">&lt;</span> <span class="n">threshold</span><span class="p">:</span>
                <span class="k">continue</span>

            <span class="n">t</span><span class="p">,</span> <span class="n">i</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">T</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">clean_cycle_method</span><span class="p">(</span><span class="n">dis_cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="o">=</span><span class="n">i_cutoff</span><span class="p">,</span>
                                                 <span class="n">min_len</span><span class="o">=</span><span class="n">min_len</span><span class="p">)</span>
                                                    <span class="c1"># cleaning the data</span>
            <span class="k">if</span> <span class="n">t</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="n">dis_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">t</span><span class="p">,</span> <span class="n">i</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">T</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="c1"># Creating the Clean_Cycle class for this discharge cycle</span>
            <span class="n">dis_clean</span> <span class="o">=</span> <span class="n">Clean_Cycle</span><span class="p">(</span><span class="n">dis_cycle</span><span class="p">,</span> <span class="n">dis_data</span><span class="p">)</span>

            <span class="c1">##</span>

            <span class="c1"># Now for the charge cycle:</span>
            <span class="n">t</span><span class="p">,</span> <span class="n">i</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">T</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">clean_cycle_method</span><span class="p">(</span><span class="n">chr_cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="o">=</span><span class="n">i_cutoff</span><span class="p">,</span>
                                                 <span class="n">min_len</span><span class="o">=</span><span class="n">min_len</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">t</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">continue</span>

            <span class="n">chr_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">t</span><span class="p">,</span> <span class="n">i</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">T</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
            <span class="n">chr_clean</span> <span class="o">=</span> <span class="n">Clean_Cycle</span><span class="p">(</span><span class="n">chr_cycle</span><span class="p">,</span> <span class="n">chr_data</span><span class="p">)</span>

            <span class="c1"># Saving the cycle couple</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_clean</span><span class="p">,</span> <span class="n">dis_clean</span><span class="p">))</span>

        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">)):</span>
            <span class="c1"># Defining the capacity point</span>
            <span class="n">capacity_point</span> <span class="o">=</span> <span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">)</span>
            <span class="c1"># Saving the capacity point</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">capacity_point</span><span class="p">)</span>

        <span class="c1"># Searching for outliers in the capacity data</span>
        <span class="n">cycle_couple</span><span class="p">,</span> <span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">Outliers</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="p">,</span> <span class="n">z_lim</span><span class="o">=</span><span class="n">z_lim</span>
        <span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="n">cycle_couple</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">capacity_curve</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">raw_couples</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">couples</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">couples</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">cycle_couple</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">:</span>
            <span class="n">chr_nb</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">number</span>
            <span class="n">dis_nb</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">number</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">couples</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_nb</span><span class="p">,</span> <span class="n">dis_nb</span><span class="p">))</span>

<div class="viewcode-block" id="Clean_Battery.clean_cycle_method"><a class="viewcode-back" href="../sphinx/NASA.html#Nasa_Classes.Clean_Battery.clean_cycle_method">[docs]</a>    <span class="k">def</span> <span class="nf">clean_cycle_method</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="o">=</span><span class="mf">2e-2</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function for cleaning current, voltage and temperature data for a given</span>
<span class="sd">        cycle.</span>

<span class="sd">        The cleaning is done by removing outliers and then the first few and</span>
<span class="sd">        last points of the cycle, when the current is being adjusted.</span>
<span class="sd">        Impedance cycles are not supported, only charge and discharge.</span>

<span class="sd">        This function is called upon initialization of a Clean_Battery class</span>
<span class="sd">        (see Nasa_Classes.py for more information).</span>

<span class="sd">        .. note::</span>
<span class="sd">            This function uses the convention where the discharge current is</span>
<span class="sd">            negative and the charge current positive.</span>
<span class="sd">            If the cycle is deemed as too short or abnormal, then all of the</span>
<span class="sd">            arrays are returned as None.</span>

<span class="sd">        .. warning::</span>
<span class="sd">            This discharge cycle cleaning only works for constant current (CC)</span>
<span class="sd">            discharge cycles. This must be adapted for more complex discharge</span>
<span class="sd">            curves if they are to be used in the future.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        Cycle : Nasa_Cycle</span>
<span class="sd">            The Cycle we want to clean.</span>
<span class="sd">        i_cutoff : float, default = 2e-2</span>
<span class="sd">            The current cut-off value to be used to determine the end of the</span>
<span class="sd">            charge cycles [A].</span>

<span class="sd">        min_len : int, default = 1</span>
<span class="sd">            The minimum amount of points a charge cycle must have to be</span>
<span class="sd">            considered as relevant. Equal to one by default. Something similar</span>
<span class="sd">            is done during the resampling stages in the dataset creation.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        Cycle_t : ndarray[float]</span>
<span class="sd">            The cycle&#39;s time stamps after cleaning [s].</span>
<span class="sd">        Cycle_i : ndarray[float]</span>
<span class="sd">            The cycle&#39;s current values after cleaning [A].</span>
<span class="sd">        Cycle_v : ndarray[float]</span>
<span class="sd">            The cycle&#39;s voltage values after cleaning [V].</span>
<span class="sd">        Cycle_T : ndarray[float]</span>
<span class="sd">            The cycle&#39;s temperature after cleaning [ºC].</span>

<span class="sd">        Raises</span>
<span class="sd">        ------</span>
<span class="sd">        AssertionError</span>
<span class="sd">            If `Cycle.type` == &#39;impedance&#39;.</span>
<span class="sd">            If `min_len` &lt; 1.</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">assert</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">!=</span> <span class="s1">&#39;impedance&#39;</span><span class="p">,</span>\
            <span class="s1">&#39;Only charge and discharge cycles are allowed.&#39;</span>
        <span class="k">assert</span> <span class="n">min_len</span> <span class="o">&gt;=</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;min_len must be greater or equal to 1&#39;</span>

        <span class="c1"># Numpy arrays</span>
        <span class="n">Cycle_t</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">time</span>  <span class="c1"># Time data</span>
        <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_i</span>  <span class="c1"># Current data</span>
        <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_v</span>  <span class="c1"># Voltage data</span>
        <span class="n">Cycle_T</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_t</span>  <span class="c1"># Temperature data</span>

        <span class="n">Data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_t</span><span class="p">,</span> <span class="n">Cycle_i</span><span class="p">,</span> <span class="n">Cycle_v</span><span class="p">,</span> <span class="n">Cycle_T</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

        <span class="c1"># Taking away outliers that may mess up with the rest of the cleaning:</span>
        <span class="n">Data</span><span class="p">,</span> <span class="n">out_idx</span> <span class="o">=</span> <span class="n">Input_outliers_v3</span><span class="p">(</span><span class="n">Data</span><span class="p">,</span> <span class="n">feature_index</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">window</span><span class="o">=</span><span class="mi">50</span><span class="p">)</span>

        <span class="n">Cycle_t</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">:</span><span class="mi">1</span><span class="p">]</span>
        <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
        <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">:</span><span class="mi">3</span><span class="p">]</span>
        <span class="n">Cycle_T</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">3</span><span class="p">:</span><span class="mi">4</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;charge&#39;</span><span class="p">:</span>
            <span class="c1"># Cutting out the beginning of the CCCV curve</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">idx</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span> <span class="o">&gt;</span> <span class="mf">0.90</span> <span class="o">*</span> <span class="nb">max</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">))</span>
                <span class="n">idx_1</span> <span class="o">=</span> <span class="n">idx</span><span class="p">[</span>
                    <span class="mi">0</span><span class="p">]</span>  <span class="c1"># Taking the very first value that is &gt; 0.9*max(Cycle_i)</span>
                <span class="c1"># We check where the current is &gt; 0.9*max(i), then we take away</span>
                <span class="c1"># everything that comes before it, which corresponds to the part</span>
                <span class="c1"># where the current hasn&#39;t yet stabilized at the CC value.</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="c1"># Just in case, I don&#39;t think this is even possible.</span>
                <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

            <span class="c1"># Now cutting the final part of the charge curve</span>
            <span class="k">if</span> <span class="n">Cycle_i</span><span class="p">[</span>
                <span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">&lt;=</span> <span class="n">i_cutoff</span><span class="p">:</span>  <span class="c1"># If the current reaches the cut-off value:</span>
                <span class="n">idx</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1</span><span class="p">:,</span>
                                  <span class="p">:]</span> <span class="o">&lt;</span> <span class="n">i_cutoff</span><span class="p">)</span>  <span class="c1"># Then check when it &lt; than it</span>
                <span class="n">idx_2</span> <span class="o">=</span> <span class="n">idx</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">idx_1</span>  <span class="c1"># And save the first value</span>

                <span class="c1"># Notice that we add idx_1 because we called np.where for</span>
                <span class="c1"># Cycle_i[idx_1:, :] and not simply Cycle_i this is because</span>
                <span class="c1"># there may be points at the beginning of the curve that satisfy</span>
                <span class="c1"># the condition</span>

                <span class="c1"># Oh my god these comments are a mess, I&#39;m so sorry</span>

            <span class="k">else</span><span class="p">:</span>  <span class="c1"># If the current never reaches the cut-off value, then:</span>
                <span class="n">idx_2</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">)</span>  <span class="c1"># idx_2 is the last point in Cycle_i</span>

        <span class="k">elif</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;discharge&#39;</span><span class="p">:</span>
            <span class="c1"># We start by taking away the first few points, where the current</span>
            <span class="c1"># hasn&#39;t yet reached its max (min because it&#39;s negative) value.</span>
            <span class="k">try</span><span class="p">:</span>  <span class="c1"># Analogous to the charge cycle.</span>
                <span class="n">idx</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span> <span class="o">&lt;</span> <span class="mf">0.90</span> <span class="o">*</span> <span class="nb">min</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">))</span>
                <span class="n">idx_1</span> <span class="o">=</span> <span class="n">idx</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="k">except</span><span class="p">:</span>
                <span class="c1"># Just in case, I don&#39;t think this is even possible.</span>
                <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

            <span class="c1"># Here we cut off the last bit of the curve where the current is</span>
            <span class="c1"># yet again lifted. It has been written in function of a Voltage</span>
            <span class="c1"># cut-off instead, since this is more general and should</span>
            <span class="c1"># work for more complex discharge cycles (to be studied).</span>
            <span class="c1"># It definitely works for harmonic discharge cycles</span>
            <span class="k">if</span> <span class="n">Cycle_v</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">&gt;=</span> <span class="nb">min</span><span class="p">(</span><span class="n">Cycle_v</span><span class="p">):</span>  <span class="c1"># Analogous to the charge cycle.</span>
                <span class="n">idx</span><span class="p">,</span> <span class="n">_</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_v</span><span class="p">[</span><span class="n">idx_1</span><span class="p">:,</span> <span class="p">:]</span> <span class="o">&lt;=</span> <span class="nb">min</span><span class="p">(</span><span class="n">Cycle_v</span><span class="p">))</span>
                <span class="n">idx_2</span> <span class="o">=</span> <span class="n">idx</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">idx_1</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">idx_2</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">Cycle_v</span><span class="p">)</span>

        <span class="c1"># Taking only the relevant data</span>
        <span class="n">Cycle_t</span> <span class="o">=</span> <span class="n">Cycle_t</span><span class="p">[</span><span class="n">idx_1</span><span class="p">:</span> <span class="n">idx_2</span><span class="p">,</span> <span class="p">:]</span>
        <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1</span><span class="p">:</span> <span class="n">idx_2</span><span class="p">,</span> <span class="p">:]</span>
        <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Cycle_v</span><span class="p">[</span><span class="n">idx_1</span><span class="p">:</span> <span class="n">idx_2</span><span class="p">,</span> <span class="p">:]</span>
        <span class="n">Cycle_T</span> <span class="o">=</span> <span class="n">Cycle_T</span><span class="p">[</span><span class="n">idx_1</span><span class="p">:</span> <span class="n">idx_2</span><span class="p">,</span> <span class="p">:]</span>

        <span class="c1"># Checking if there are any NaNs and taking them away.aa</span>
        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">any</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">)))</span><span class="o">.</span><span class="n">item</span><span class="p">():</span>
            <span class="n">nan_t</span> <span class="o">=</span> <span class="o">~</span><span class="n">np</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">Cycle_t</span><span class="p">)</span>
            <span class="n">nan_i</span> <span class="o">=</span> <span class="o">~</span><span class="n">np</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">)</span>
            <span class="n">nan_v</span> <span class="o">=</span> <span class="o">~</span><span class="n">np</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">Cycle_v</span><span class="p">)</span>
            <span class="n">nan_T</span> <span class="o">=</span> <span class="o">~</span><span class="n">np</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">Cycle_T</span><span class="p">)</span>
            <span class="n">isnt_nan</span> <span class="o">=</span> <span class="n">nan_t</span> <span class="o">&amp;</span> <span class="n">nan_i</span> <span class="o">&amp;</span> <span class="n">nan_T</span> <span class="o">&amp;</span> <span class="n">nan_v</span>

            <span class="n">Cycle_t</span> <span class="o">=</span> <span class="n">Cycle_t</span><span class="p">[</span><span class="n">isnt_nan</span><span class="p">]</span>
            <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Cycle_i</span><span class="p">[</span><span class="n">isnt_nan</span><span class="p">]</span>
            <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Cycle_v</span><span class="p">[</span><span class="n">isnt_nan</span><span class="p">]</span>
            <span class="n">Cycle_T</span> <span class="o">=</span> <span class="n">Cycle_T</span><span class="p">[</span><span class="n">isnt_nan</span><span class="p">]</span>

            <span class="n">Cycle_t</span> <span class="o">=</span> <span class="n">Cycle_t</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="nb">len</span><span class="p">(</span><span class="n">Cycle_t</span><span class="p">),</span> <span class="mi">1</span><span class="p">))</span>
            <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Cycle_i</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="nb">len</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">),</span> <span class="mi">1</span><span class="p">))</span>
            <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Cycle_v</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="nb">len</span><span class="p">(</span><span class="n">Cycle_v</span><span class="p">),</span> <span class="mi">1</span><span class="p">))</span>
            <span class="n">Cycle_T</span> <span class="o">=</span> <span class="n">Cycle_T</span><span class="o">.</span><span class="n">reshape</span><span class="p">((</span><span class="nb">len</span><span class="p">(</span><span class="n">Cycle_T</span><span class="p">),</span> <span class="mi">1</span><span class="p">))</span>

        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Cycle_t</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">min_len</span><span class="p">:</span>  <span class="c1"># If the Cycle is too short, than we&#39;ll skip</span>
            <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

        <span class="k">return</span> <span class="n">Cycle_t</span><span class="p">,</span> <span class="n">Cycle_i</span><span class="p">,</span> <span class="n">Cycle_v</span><span class="p">,</span> <span class="n">Cycle_T</span></div></div>

<div class="viewcode-block" id="Clean_Cycle"><a class="viewcode-back" href="../sphinx/NASA.html#Nasa_Classes.Clean_Cycle">[docs]</a><span class="k">class</span> <span class="nc">Clean_Cycle</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Class structured just like a Nasa_Cycle, but only containing the relevant</span>
<span class="sd">    cleaned data that is relevant for analysis.</span>

<span class="sd">    In this regard, this class is incompatible with impedance cycles.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Cycle : Nasa_Cycle</span>
<span class="sd">        The Nasa_Cycle object corresponding to this cycle.</span>
<span class="sd">    Data : ndarray[floats]</span>
<span class="sd">        The array containing all of the data.</span>
<span class="sd">        Each column corresponds to a different variable, in the following</span>
<span class="sd">        order: Time [s], Current [A], Voltage [V] and Temperature [ºC].</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    type : {&#39;charge&#39;, &#39;discharge&#39;}</span>
<span class="sd">        The type of cycle.</span>
<span class="sd">    amb_T : int</span>
<span class="sd">        The ambient temperature during measurements [ºC].</span>
<span class="sd">        (The raw data was already an integer, I just kept it this way)</span>
<span class="sd">    time : datetime.datetime</span>
<span class="sd">        The date and time of the experiment.</span>
<span class="sd">    unix_time : float</span>
<span class="sd">        The date and time of the experiment expressed in unix time [s].</span>
<span class="sd">    data : Clean_Data</span>
<span class="sd">        Clean_Data class containing all of the actual data.</span>
<span class="sd">        See Clean_Data for more information.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Cycle</span><span class="p">,</span> <span class="n">Data</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">number</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">type</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">amb_T</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">time</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">unix_time</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">unix_time</span>
        <span class="k">if</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="s1">&#39;discharge&#39;</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">Clean_Data</span><span class="p">(</span><span class="n">Data</span><span class="p">,</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">Clean_Data</span><span class="p">(</span><span class="n">Data</span><span class="p">)</span></div>

<div class="viewcode-block" id="Clean_Data"><a class="viewcode-back" href="../sphinx/NASA.html#Nasa_Classes.Clean_Data">[docs]</a><span class="k">class</span> <span class="nc">Clean_Data</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Clean_Data class. Stores the cleaned data of one Clean_Cycle</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Data : ndarray[floats]</span>
<span class="sd">        The array containing all of the data.</span>
<span class="sd">        Each column corresponds to a different variable, in the following</span>
<span class="sd">        order: Time [s], Current [A], Voltage [V] and Temperature [ºC].</span>
<span class="sd">    Capacity : float, optional</span>
<span class="sd">        The capacity value.</span>
<span class="sd">        This is only necessary for discharge cycles, unit should be [A.h].</span>
<span class="sd">        If the cycle is a charge cycle then it defaults to None.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    meas_v : ndarray[floats]</span>
<span class="sd">        Battery terminal voltage [V].</span>
<span class="sd">    meas_i : ndarray[floats]</span>
<span class="sd">        Battery output current [A].</span>
<span class="sd">    meas_t : ndarray[floats]</span>
<span class="sd">        Battery temperature [ºC].</span>
<span class="sd">    time : ndarray[floats]</span>
<span class="sd">        Time vector for the cycle [s].</span>
<span class="sd">    capacity</span>
<span class="sd">        For a discharge cycle, the capacity value [A.h], float.</span>
<span class="sd">        If it&#39;s a charge cycle, then it is None.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Data</span><span class="p">,</span> <span class="n">Capacity</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="c1"># Time</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">:</span><span class="mi">1</span><span class="p">]</span>
        <span class="c1"># Current_measured</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
        <span class="c1"># Voltage_measured</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">:</span><span class="mi">3</span><span class="p">]</span>
        <span class="c1"># Temperature_measured</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_t</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">3</span><span class="p">:]</span>
        <span class="c1"># Capacity</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="n">Capacity</span></div>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>

    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/NASA/B. Saha and K Goebel&#39;</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Raw_Batteries (Dataset_Nasa classes)&#39;</span><span class="p">)</span>
    <span class="c1"># os.mkdir(&#39;Clean_Batteries&#39;)</span>

    <span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>  <span class="c1"># All files in the folder</span>
    <span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>  <span class="c1"># List with the valid files</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
        <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>  <span class="c1"># Only take into acount</span>
        <span class="c1"># the battery files</span>
        <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

    <span class="n">ignore</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B0049.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0050.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0051.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;B0052.txt&#39;</span><span class="p">]</span>

    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">New_Battery</span> <span class="o">=</span> <span class="n">Clean_Battery</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Clean_Batteries&#39;</span><span class="p">)</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">New_Battery</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>

    <span class="c1"># os.chdir(&#39;.//Datasets/NASA/B. Saha and K Goebel&#39;)</span>
    <span class="c1">#</span>
    <span class="c1"># # All of Nasa&#39;s Datasets:</span>
    <span class="c1"># os.chdir(&#39;.//Compiled_datasets&#39;)</span>
    <span class="c1">#</span>
    <span class="c1"># import time</span>
    <span class="c1"># start = time.time()</span>
    <span class="c1">#</span>
    <span class="c1"># for i in os.listdir():</span>
    <span class="c1">#     if i == &#39;.DS_Store&#39;:</span>
    <span class="c1">#         continue</span>
    <span class="c1">#</span>
    <span class="c1">#     print(i)</span>
    <span class="c1">#     B = Dataset_Nasa(i)</span>
    <span class="c1">#</span>
    <span class="c1">#     os.chdir(&#39;../Old_Batteries&#39;)</span>
    <span class="c1">#</span>
    <span class="c1">#     with open(B.Name+&#39;.txt&#39;, &#39;wb&#39;) as file:</span>
    <span class="c1">#         pickle.dump(B, file)</span>
    <span class="c1">#</span>
    <span class="c1">#     os.chdir(&#39;../Compiled_datasets&#39;)</span>
    <span class="c1">#</span>
    <span class="c1"># end = time.time()</span>
    <span class="c1"># print(end - start)</span>
    <span class="c1"># # B0052.mat and B0050.mat have missing values of Capacity (B0052.mat in particular)</span>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>